SystemOrganization addCategory: #'OB-ToolBuilder'!

!OBColumn methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:35'!
buildWith: builder inFrame: frame addTo: list
	| spec |
	spec := (builder pluggablePanelSpec new)
		model: self;
		children: #widgets;
		frame: frame.
	list add: spec! !

!OBColumn methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/6/2011 00:05'!
widgets
	| builder list |
	builder := ToolBuilder default.
	list := (builder pluggableListSpec new)
			model: self;
			list: #list;
			menu: #menu:;
			getIndex: #selection;
			setIndex: #selection:;
			doubleClick: #doubleClick.
	^ switch isActive 
		ifTrue:
			[| divider buttons |
			divider := OBPlatform current buttonHeight negated - builder gutter.
			list frame: (LayoutFrame new
				leftFraction: 0 offset: 0;
				topFraction: 0 offset: 0;
				rightFraction: 1 offset: 0;
				bottomFraction: 1offset: divider).
			
			buttons := builder build: switch.
			buttons frame: (LayoutFrame new
				leftFraction: 0 offset: 0;
				topFraction: 1 offset: divider;
				rightFraction: 1 offset: 0;
				bottomFraction: 1 offset: 0).
			{builder build: list. builder build: buttons}]
		ifFalse:
			[list frame: (0@0 corner: 1@1).
			{builder build: list}]
				
! !

!OBButtonBar class methodsFor: '*ob-toolbuilder-layout' stamp: 'cwp 11/7/2011 00:24'!
layoutSpecs: specs gutter: gutter
	| minSize total x  |
	minSize := 3.
	total := specs inject: 0 into: 
		[:sum :ea || label |
		label := ea model perform: ea label.
		 sum + (label size max: minSize)].
	x := 0.
	specs do:
		[:spec || label frame |
		label := label := spec model perform: spec label.
		frame := LayoutFrame new
			topFraction: 0 offset: gutter;
			bottomFraction: 1 offset: 0;
			leftFraction: x / total offset: 0.
		x := x + (label size max: minSize).
		frame rightFraction: x / total offset: 0. 
		spec frame: frame].
	! !

!OBButtonBar methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 23:21'!
buildWith: builder
	^ (builder pluggablePanelSpec new)
		model: self;
		children: #widgets! !

!OBButtonBar methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/7/2011 00:20'!
widgets
	| builder specs |
	builder := OBBuilderRequest signal.
	specs := buttons collect: [:button | builder build: button].
	self class layoutSpecs: specs gutter: builder gutter.
	^ specs collect: [:spec | builder build: spec]! !

OBInteractionRequest subclass: #OBBuilderRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-ToolBuilder'!

!OBBuilderRequest methodsFor: 'as yet unclassified' stamp: 'cwp 11/6/2011 00:04'!
defaultAction
	^ self resume: ToolBuilder default! !

!OBFixedButtonPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:37'!
buildWith: builder
	^ (builder pluggablePanelSpec new)
		model: self;
		children: #widgets;
		yourself! !

!OBFixedButtonPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/7/2011 00:25'!
widgets
	| builder commands specs |
	builder := ToolBuilder default.
	commands := self commands.
	specs := commands collect: 
		[:ea |
		(builder pluggableActionButtonSpec new)
			model: ea;
			action: #execute;
			enabled: #isEnabled;
			label: #buttonLabel].
	OBButtonBar layoutSpecs: specs gutter: 0.
	^ specs collect: [:ea | builder build: ea]! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:36'!
buildDynamicWith: builder inFrame: frame addTo: specs
	| spec |
	spec := (builder pluggablePanelSpec new)
		model: self;
		frame: frame;
		children: #widgets.
	specs add: spec! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/4/2011 00:35'!
buildStaticWith: builder inFrame: aFrame addTo: specs
	| fraction fractionStep offset offsetStep |
	fraction := aFrame leftFraction.
	offset := aFrame leftOffset.
	fractionStep := aFrame rightFraction - fraction / maxPanes.
	offsetStep := aFrame rightOffset - offset / maxPanes.
	(columns last: maxPanes) do:
		[:ea || frame |
		frame := LayoutFrame new.
		frame
			topFraction: aFrame topFraction offset: aFrame topOffset;
			bottomFraction: aFrame bottomFraction offset: aFrame bottomOffset;
			leftFraction: fraction offset: offset.
		fraction := fraction + fractionStep.
		offset := offset + offsetStep.
		frame rightFraction: fraction offset: offset.
		ea buildWith: builder inFrame: frame addTo: specs]! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/4/2011 00:34'!
buildWith: builder inFrame: frame addTo: specs
	minPanes = maxPanes
		ifTrue: [self buildStaticWith: builder inFrame: frame addTo: specs]
		ifFalse: [self buildDynamicWith: builder inFrame: frame addTo: specs]
! !

!OBColumnPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 15:36'!
widgets
	| count index builder |
	builder := ToolBuilder default.
	count := (columns size max: minPanes) min: self maxPanes.
	index := 0.
	^ (columns last: count) collect:
		[:ea || spec topLeft bottomRight |
		topLeft := index / count @ 0.
		index := index + 1.
		bottomRight := index / count @ 1.
		spec := builder build: ea.
		spec frame: (topLeft corner: bottomRight).
		builder build: spec]! !

!OBDefinitionPanel methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/3/2011 16:18'!
buildWith: builder
	^ (builder pluggableTextSpec new)
		model: self;
		getText: #text;
		setText: #accept:notifying:;
		selection: #selection;
		menu: #menu:shifted:selection:;
		yourself! !

!MenuMorph methodsFor: '*ob-toolbuilder' stamp: 'cwp 11/4/2011 22:04'!
add: label target: anObject selector: aSelector enabled: aBoolean icon: aSymbol keystroke: aKeystroke
	self add: label target: anObject selector: aSelector.
	self lastItem isEnabled: aBoolean.
	anObject longDescription isNil ifFalse: 
		[ self lastItem setBalloonText: anObject longDescription maxLineLength: 256 ].
	OBPlatform current menuWithIcons ifTrue: 
		[ self lastItem icon: (self iconNamed: aSymbol) ].
	aKeystroke isNil ifFalse: 
		[ self lastItem keyText: aKeystroke asKeystroke printString ]! !

!OBBrowser methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/4/2011 22:11'!
buildWith: builder
	^ (builder pluggableWindowSpec new)
		model: self;
		label: self labelString asString;
		color: self defaultBackgroundColor;
		children: self childSpecs;
		buildWith: builder! !

!OBBrowser methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/5/2011 11:45'!
childSpecs
	| builder fraction frame offset variable specs |
	builder := ToolBuilder default.
	variable := panels count: [:ea | ea isVerticallyElastic].
	fraction := 0.
	offset := 0.
	specs := OrderedCollection new.
	panels do:
		[:ea |
		frame := LayoutFrame new.
		frame leftFraction: 0 offset: 0.
		frame rightFraction: 1 offset: 0.
		frame topFraction: fraction offset: offset.
		ea isVerticallyElastic
			ifFalse: 	[offset := offset + builder buttonHeight + builder gutter]
			ifTrue:	[fraction := fraction + (1 / variable).
					offset := 0].
		frame bottomFraction: fraction offset: offset.
		ea buildWith: builder inFrame: frame addTo: specs].
	^ specs
	! !

!OBSwitch methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/6/2011 22:36'!
buildWith: builder
	^ bar buildWith: builder! !

!MorphicToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/5/2011 11:46'!
buttonHeight
	^ OBPlatform current buttonHeight! !

!MorphicToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/5/2011 11:45'!
gutter
	^ 5! !

!MenuItemMorph methodsFor: '*ob-toolbuilder' stamp: 'cwp 11/4/2011 22:08'!
keyText: aString
	contents := contents, ' (', aString, ')'! !

OBInterface subclass: #OBToolBuilderInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-ToolBuilder'!

!OBToolBuilderInterface class methodsFor: 'as yet unclassified' stamp: 'cwp 11/3/2011 12:09'!
initialize
	OBInterface default: self new! !

!OBToolBuilderInterface methodsFor: 'building' stamp: 'cwp 11/6/2011 00:04'!
build: aModel
	^  self builder build: aModel! !

!OBToolBuilderInterface methodsFor: 'building' stamp: 'cwp 11/6/2011 00:03'!
builder
	^ OBBuilderRequest signal! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/3/2011 11:57'!
handleBrowseRequest: request
	ToolBuilder open: request browser.
	^ request browser! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'dc 9/18/2007 10:48'!
handleChoiceRequest: request
	^ UIManager default
		chooseFrom: request labels
		values: request values
		lines: request lines
		title: (request prompt ifNil: [''])! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 9/25/2010 16:09'!
handleCloseRequest: request 
	(OBSystemWindow allInstances 
		detect: [ :each | each model = request browser ]
		ifNone: [ ^ nil ]) delete! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'cwp 11/7/2011 00:09'!
handleCompletionRequest: aRequest
	| labels values choice |
	values := aRequest valuesFor: ''.
	labels := values collect: [:ea | aRequest labelFor: ea].
	choice := ListChooser chooseIndexFrom: labels title: aRequest prompt addAllowed: true.
	^ values at: choice ifAbsent: [nil].! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 7/19/2010 13:00'!
handleConfirmationRequest: request
	| choice |
	choice := UIManager default
		confirm: request prompt
		trueChoice: request okChoice
		falseChoice: request cancelChoice.
	^ choice
		ifNil: [ false ]
		ifNotNil: [ choice ]! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 7/4/2009 16:43'!
handleInformRequest: anOBInformRequest 
	UIManager default inform: anOBInformRequest message! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 7/4/2009 16:43'!
handleMultiLineTextRequest: request
	^ UIManager default
			multiLineRequest: request prompt
			centerAt: Sensor cursorPoint
			initialAnswer: request template
			answerHeight: 200! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 10/11/2009 12:18'!
handleMultipleChoiceRequest: aRequest
	| menu |
	aRequest values isEmpty
		ifTrue: [ ^ aRequest values ].
	menu := MenuMorph new.
	menu stayUp: true.
	aRequest prompt isEmptyOrNil
		ifFalse: [ menu addTitle: aRequest prompt ].
	aRequest values do: [ :value |
		menu
			addUpdating: #label: target: aRequest selector: #toggleMorphic:
			argumentList: (Array with: value) ].
	menu addLine.
	menu add: 'ok' target: menu selector: #delete.
	menu invokeModal.
	^ aRequest selection asArray! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'DamienCassou 9/20/2009 15:55'!
handleTextRequest: request
	| text |
	text := UIManager default
				request:request prompt
				initialAnswer: request template.
	^ (text isNil or: [text isEmpty])
		ifTrue: [nil]
		ifFalse: [text]! !

!OBToolBuilderInterface methodsFor: 'interaction' stamp: 'lr 5/14/2008 15:42'!
handleWaitRequest: request
	^ Cursor wait showWhile: request block! !

!OBButton methodsFor: '*ob-toolbuilder-building' stamp: 'cwp 11/6/2011 23:01'!
buildWith: builder
	| spec |
	spec := builder pluggableButtonSpec new.
	spec
		model: self;
		label: #label;
		action: #execute;
		state: #isPressed;
		enabled: #isEnabled.
	color ifNotNil: [spec color: #color].
	^ spec! !

!SUnitToolBuilder methodsFor: '*ob-toolbuilder-constants' stamp: 'cwp 11/7/2011 00:35'!
gutter
	^ 5! !
OBToolBuilderInterface initialize!
